| Version: 3.0.1

- Main Page
- Related Pages
- Categories
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
wxFocusEvent Class Reference
Events

`#include <wx/event.h>`

Inheritance diagram for wxFocusEvent:
[legend]

## Detailed Description

A focus event is sent when a window's focus changes.

The window losing focus receives a "kill focus" event while the window gaining it gets a "set focus" one.

Notice that the set focus event happens both when the user gives focus to the window (whether using the mouse or keyboard) and when it is done from the program itself using wxWindow::SetFocus.

The focus event handlers should almost invariably call wxEvent::Skip() on their event argument to allow the default handling to take place. Failure to do this may result in incorrect behaviour of the native controls. Also note that wxEVT_KILL_FOCUS handler must not call wxWindow::SetFocus() as this, again, is not supported by all native controls. If you need to do this, consider using the Delayed Action Mechanism described in wxIdleEvent documentation.

## Events using this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxFocusEvent& event)

Event macros:

- EVT_SET_FOCUS(func):
  Process a `wxEVT_SET_FOCUS` event.
- EVT_KILL_FOCUS(func):
  Process a `wxEVT_KILL_FOCUS` event.

##

Library: wxCore
Category: Events

See Also
  Events and Event Handling

## Public Member Functions

| wxFocusEvent (wxEventType eventType=wxEVT_NULL, int id=0)
| Constructor.
wxWindow * | GetWindow () const
| Returns the window associated with this event, that is the window which had the focus before for the `wxEVT_SET_FOCUS` event and the window which is going to receive focus for the `wxEVT_KILL_FOCUS` one.
void | SetWindow (wxWindow *win)
Public Member Functions inherited from wxEvent
| wxEvent (int id=0, wxEventType eventType=wxEVT_NULL)
| Constructor.
virtual wxEvent * | Clone () const =0
| Returns a copy of the event.
wxObject * | GetEventObject () const
| Returns the object (usually a window) associated with the event, if any.
wxEventType | GetEventType () const
| Returns the identifier of the given event type, such as `wxEVT_BUTTON`.
virtual wxEventCategory | GetEventCategory () const
| Returns a generic category for this event.
int | GetId () const
| Returns the identifier associated with this event, such as a button command id.
wxObject * | GetEventUserData () const
| Return the user data associated with a dynamically connected event handler.
bool | GetSkipped () const
| Returns true if the event handler should be skipped, false otherwise.
long | GetTimestamp () const
| Gets the timestamp for the event.
bool | IsCommandEvent () const
| Returns true if the event is or is derived from wxCommandEvent else it returns false.
void | ResumePropagation (int propagationLevel)
| Sets the propagation level to the given value (for example returned from an earlier call to wxEvent::StopPropagation).
void | SetEventObject (wxObject *object)
| Sets the originating object.
void | SetEventType (wxEventType type)
| Sets the event type.
void | SetId (int id)
| Sets the identifier associated with this event, such as a button command id.
void | SetTimestamp (long timeStamp=0)
| Sets the timestamp for the event.
bool | ShouldPropagate () const
| Test if this event should be propagated or not, i.e. if the propagation level is currently greater than 0.
void | Skip (bool skip=true)
| This method can be used inside an event handler to control whether further event handlers bound to this event will be called after the current one returns.
int | StopPropagation ()
| Stop the event from propagating to its parent window.
Public Member Functions inherited from wxObject
| wxObject ()
| Default ctor; initializes to NULL the internal reference data.
| wxObject (const wxObject &other)
| Copy ctor.
virtual | ~wxObject ()
| Destructor.
virtual wxClassInfo * | GetClassInfo () const
| This virtual function is redefined for every class that requires run-time type information, when using the wxDECLARE_CLASS macro (or similar).
wxObjectRefData * | GetRefData () const
| Returns the wxObject::m_refData pointer, i.e. the data referenced by this object.
bool | IsKindOf (const wxClassInfo *info) const
| Determines whether this class is a subclass of (or the same class as) the given class.
bool | IsSameAs (const wxObject &obj) const
| Returns true if this object has the same data pointer as obj.
void | Ref (const wxObject &clone)
| Makes this object refer to the data in clone.
void | SetRefData (wxObjectRefData *data)
| Sets the wxObject::m_refData pointer.
void | UnRef ()
| Decrements the reference count in the associated data, and if it is zero, deletes the data.
void | UnShare ()
| This is the same of AllocExclusive() but this method is public.
void | operator delete (void *buf)
| The delete operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.
void * | operator new (size_t size, const wxString &filename=NULL, int lineNum=0)
| The new operator is defined for debugging versions of the library only, when the identifier `WXDEBUG` is defined.

## Additional Inherited Members

Protected Member Functions inherited from wxObject
void | AllocExclusive ()
| Ensure that this object's data is not shared with any other object.
virtual wxObjectRefData * | CreateRefData () const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and returns it.
virtual wxObjectRefData * | CloneRefData (const wxObjectRefData *data) const
| Creates a new instance of the wxObjectRefData-derived class specific to this object and initializes it copying data.
Protected Attributes inherited from wxEvent
int | m_propagationLevel
| Indicates how many levels the event can propagate.

## Constructor & Destructor Documentation

wxFocusEvent::wxFocusEvent | ( | wxEventType | eventType = `wxEVT_NULL`,
|  | int | id = `0`
| ) |  |

Constructor.

## Member Function Documentation

wxWindow* wxFocusEvent::GetWindow | ( |  | ) | const

Returns the window associated with this event, that is the window which had the focus before for the `wxEVT_SET_FOCUS` event and the window which is going to receive focus for the `wxEVT_KILL_FOCUS` one.

Warning: the window pointer may be NULL!

void wxFocusEvent::SetWindow | ( | wxWindow * | win | ) |